--This script will run on all levels when mod is active.
--Modding documentation: http://teardowngame.com/modding
--API reference: http://teardowngame.com/modding/api.html
--UwQ's Code:
--©UwQ_ No Rights Reserved.
-- ^Bandi Was HERE!

toolAtribs = {
	LookingSelf = false,
	MirrorRotation = 0,
	LowerBand = -15, -- How far u can rotate into Negatives
	UpperBand = 180,
	FaceInstance = nil,
}


function init()
	RegisterTool("mirror", "Mirror", "MOD/voxelation/mirror.vox", "1")
	SetBool("game.tool.mirror.enabled", true)
end


function tick(dt)

	if GetString("game.player.tool") == "mirror" and GetPlayerVehicle() == 0 then
		if InputDown("lmb") then
			RotateMirror(true)
			return
		end
		if InputReleased('rmb') then -- on realase
			EnableFace(false) -- Disable Face
			return
		end
		if InputDown('rmb') then
			RotateMirror(false)
			return
		end
		if toolAtribs.MirrorRotation ~= 0 then toolAtribs.MirrorRotation = 0 end
	end

end


function update(dt)
end


function draw(dt)
end

function GetFaceTransform(dist) -- Gets the exact transform of where the Head SHOULD BE
	if not dist then dist = 5 end
	
	local transform = GetCameraTransform() 
	transform.pos = TransformToParentPoint(transform, Vec(0,0,dist)) -- Relativly Position Head
	transform.rot = QuatRotateQuat(transform.rot, QuatEuler(0, 90, 0)) -- Relativly Rotate Head
	return transform
end

Shootwait = 10 -- ticks between Shots
counter = 0
function ShootReflection() -- Shoots FaceObject
	
	if counter < Shootwait then counter = counter+1 return end
	counter = 0
	
	local newTr = GetFaceTransform(-2)
	local CurrentCamera = GetCameraTransform()
	local aim_pos = TransformToParentPoint(CurrentCamera, Vec(0, 0, -7)) -- 7 units infront of camera
	
	local Clone = Spawn("<body><vox file='MOD/voxelation/Face.vox'/></body>", newTr)
	local Direction = VecSub(aim_pos,CurrentCamera.pos)
	local Power = 20
	SetBodyVelocity(Clone[1], VecScale(Direction,Power))  
end

function EnableFace(bool)
	toolAtribs.LookingSelf = bool
	
	if bool then
		toolAtribs.FaceInstance = Spawn("<vox file='MOD/voxelation/Face.vox'/>", GetFaceTransform()) -- Spawn Head
		SetBodyDynamic(toolAtribs.FaceInstance[1], false) -- Anchor body Instance
	else
		SetBodyDynamic(toolAtribs.FaceInstance[1], true) -- Set face to dynamic and forget Instance
		toolAtribs.FaceInstance = nil
	end
end




function RotateMirror(forward)
	
	local ActivePosition = nil
	local Roto = toolAtribs.MirrorRotation
	
	if forward then
		if Roto < toolAtribs.UpperBand then
			toolAtribs.MirrorRotation =  Roto + 8
		else
			ShootReflection()
		end
		ActivePosition = Vec (Roto/200,0,-Roto/200)
	else -- When rotating Backwards .. OR Looking at Self
	
		if not toolAtribs.LookingSelf then
			EnableFace(true)
		else
			SetBodyTransform(toolAtribs.FaceInstance[1], GetFaceTransform())
		end
		
		
		if Roto > toolAtribs.LowerBand then
			toolAtribs.MirrorRotation =  Roto - 1
		end
		
		ActivePosition = Vec(Roto/25,0,Roto/90)
		
	end
	
    -- Set Final Tool Transform
	local offset = Transform()
	offset.rot = QuatEuler(0, toolAtribs.MirrorRotation, 0)
	if ActivePosition then offset.pos = ActivePosition end
	SetToolTransform(t)
	SetToolTransform(offset)
end

